//---------------------------------------------------------------------------

#ifndef UnitDispH
#define UnitDispH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "ImageControl.h"
#include "FrameQueue.h"
#include "ZoomPanel.h"
#include "DDImageControl.h"
#include <ExtCtrls.hpp>
#include <time.h>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include <map>
#include "SkinModelAcquisition.h"

//---------------------------------------------------------------------------
class TFormDisp : public TForm
{
__published:	// IDE-managed Components
  TTimer *Timer1;
  TPanel *Panel3;
  TPanel *PanelP1;
  TDDImageControl *ImageControlP1;
  TPanel *PanelP2;
  TDDImageControl *ImageControlP2;
  TPanel *PanelP3;
  TDDImageControl *ImageControlP3;
  TPanel *PanelP4;
  TDDImageControl *ImageControlP4;
  TPanel *Panel4;
  TPanel *PanelW1;
  TLabel *LabelW1;
  TImage *ImageW1;
  TPanel *PanelW2;
  TLabel *LabelW2;
  TImage *ImageW2;
  TPanel *PanelW3;
  TLabel *LabelW3;
  TImage *ImageW3;
  TPanel *PanelW4;
  TLabel *LabelW4;
  TImage *ImageW4;
  TPanel *Panel5;
  TPanel *Panel1;
  TDDImageControl *ImageControlSRC;
  TPanel *Panel2;
  TDDImageControl *ImageControlTR;
  TPanel *PanelAbout;
  TLabel *Label1;
  TImage *Image1;
  TLabel *Label2;
  TImage *Image2;
  TStatusBar *StatusBar;
  TLabel *Label3;
  TLabel *Label4;
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall Panel3Resize(TObject *Sender);
  void __fastcall Panel4Resize(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall Panel5Resize(TObject *Sender);
  void __fastcall ImageControlP1Paint(TObject *Sender);
  void __fastcall ImageControlP1Click(TObject *Sender);
protected:
  virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
private:	// User declarations
  struct TKWComp {
    TPanel *Panel;
    TLabel *Label;
    TImage *Image;
    clock_t Last;
  };

  std::map<AnsiString, AnsiString> ImageFiles;
  TKWComp KWComps[PERSON_COUNT];
	TFrameBuffer *Buffer;
  int Channel;
  void UpdateKeywords();
public:		// User declarations
  SkinModelAcquisitor SkinModel;

	__fastcall TFormDisp(TComponent* Owner);
  __fastcall ~TFormDisp();
  void Display(TFrameBuffer *Buffer, bool Src, bool Trans, bool Persons);
  void SetChannel(int Channel);
  void ShowKeyword(AnsiString Keyword);
  void ClearStatus();
  void SetShowInfo(bool Value);
};
//---------------------------------------------------------------------------
#endif
